////////////////////////////////////////////////////////////////////////////////
//! \file
//! \author Adam M Phillippy
//! \date 04/18/2005
//!
//! \brief Source for utility_AMOS.hh
//!
////////////////////////////////////////////////////////////////////////////////
 
#include "utility_AMOS.hh"
#include <algorithm>
#include <cstring>
using namespace AMOS;
using namespace std;
 

const char COMPLEMENT_DNA[256] =
  {
      0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
     16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
     32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
     48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
     64,'T','V','G','H', 69, 70,'C','D', 73, 74,'M', 76,'K','N', 79,
     80, 81,'Y','S','A', 85,'B','W','X','R', 90, 91, 92, 93, 94, 95,
     96,'t','v','g','h',101,102,'c','d',105,106,'m',108,'k','n',111,
    112,113,'y','s','a',117,'b','w','x','r',122,123,124,125,126,127,
    128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
    144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
    160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
    176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
    192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
    208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
    224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
    240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
  };


//--------------------------------------------------- Complement ---------------
char AMOS::Complement (char ch)
{
  return COMPLEMENT_DNA[ int(ch) ];
}


//--------------------------------------------------- ReverseComplement --------
void AMOS::ReverseComplement(string & str)
{
  char ch;
  string::iterator lo = str.begin();
  string::iterator hi = str.end() - 1;
  while ( lo <= hi )
    {
      ch = *hi;
      *hi = COMPLEMENT_DNA[ int(*lo) ];
      *lo = COMPLEMENT_DNA[ int(ch) ];
      lo++; hi--;
    }
}


//--------------------------------------------------- ReverseComplement --------
void AMOS::ReverseComplement(char * str)
{
  char ch;
  char *lo = str;
  char *hi = str + strlen(str) - 1;
  while ( lo <= hi )
    {
      ch = *hi;
      *hi = COMPLEMENT_DNA[ int(*lo) ];
      *lo = COMPLEMENT_DNA[ int(ch) ];
      lo++; hi--;
    }
}


//--------------------------------------------------- Reverse ------------------
void AMOS::Reverse (string & str)
{
  reverse (str . begin( ), str . end( ));
}


//--------------------------------------------------- Reverse ------------------
void AMOS::Reverse (char * str)
{
  reverse (str, str + strlen (str));
}
